;
; Serial port driver for PC-9801
; rs232c.asm version 1.03
; Copyright (C) 1992-93 by Y.Akagawa
;
;  int rs_init( int, int, int, int, int );
;  int getaux( void );
;  int putaux( int );
;  int checkaux( void );
;
;

include general.inc
EXTRN	_atexit:NEAR

MAX_BUFFER	equ	1024
FLOW_LIMIT	equ	100

.model small

.data
	public	__stop
	public	_w_ptr
	public	_r_ptr
	public	_flag
;
;5/10/20MHz pe[u(2.4576MHz / 16 / baud)
;

tbl_10MHz	dw	2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4

;
;8/16MHz pe[u(1.9968MHz / 16 / baud)
;

tbl_8MHz	dw	1664, 832, 416, 208, 104, 52, 26, 13

int0coff		dw	?
int0cseg		dw	?
int06off		dw	?
int06seg		dw	?

_w_ptr		dw	0			;݃|C^
_r_ptr		dw	0			;ǂݍ݃|C^
buffer		db	MAX_BUFFER dup(0)	;Mobt@(FIFO)

int_mask	db	?
_flag		db	0
x_flow		db	1
__stop		db	0
.code

	public	_rs_init
	public	_getaux
	public	_putaux
	public	_checkaux

;
;***************************************
;*                                     *
;* int rs_init(int, int, int, int );   *
;*                                     *
;*@p[^ݒCM荞ݐݒ   *
;*                                     *
;* Entry:                              *
;*    int  bps                         *
;*    int  parity                      *
;*    int  stop_bit                    *
;*    int  data_length                 *
;*    int  x_flow                      *
;*                                     *
;* Return:                             *
;*    0 : I                     *
;*   -1 : 19200bps ȏ͐ݒs\@@*
;*                                     *
;***************************************
;
_rs_init	PROC near

	push	bp
	mov	bp, sp
	push	si
;
;{[[gݒ
;
	mov	bx, word ptr [bp+4]

	cmp	bx, 10
	mov	ax, -1

	jc	l01
	jmp	exit
l01:
	push	ds
	xor	ax, ax
	mov	ds, ax
	mov	si, 501h
	mov	al, byte ptr [si]	;VXeNbN̎擾
	pop	ds

	mov	si, offset tbl_10MHz
	test	al, 80h
	jz	skip
	mov	si, offset tbl_8MHz
	cmp	bx, 8
	mov	ax, -1
	jc	skip
	jmp	exit
skip:
	shl	bx, 1
	mov	bx, [bx+si]

	mov	al, 0b6h
	out	I8253_CW, al		;oCiEJEgC[hQ

	mov	ax, bx
	out	I8253_2, al		;{[[gCLSB Zbg
	iowait
	mov	al, ah
	out	I8253_2, al		;{[[gCMSB Zbg
;
;p[^ݒC
;
	xor	al, al
	out	I8251A_CMD, al
	iowait
	xor	al, al
	out	I8251A_CMD, al
	iowait
	xor	al, al
	out	I8251A_CMD, al
	iowait

	mov	al, 40h
	out	I8251A_CMD, al		;8251A Zbg
	iowait

	mov	al, byte ptr [bp+6]	;peB
	or	al, byte ptr [bp+8]	;Xgbvrbg
	or	al, byte ptr [bp+10]	;f[^
	or	al, 2			;{[[gt@N^~16
	out	I8251A_CMD, al		;p[^ݒ
	iowait

	mov	al, byte ptr [bp+12]	;w|e
	mov	[x_flow], al
	mov	al, 37h
	out	I8251A_CMD, al		;RTS,DTR,TxEN,RxEN Cl[u
	iowait
;
;qr|QRQb̊荞݂֎~
;
	in	al, 02h
	iowait
	or	al, 10h
	out	02h, al
;
;RxRDY荞݋
;
	in	al, I8255A_C
	mov	[int_mask], al
	iowait
	or	al, 1
	out	I8255A_C, al
	iowait

;
;荞݃xN^ݒ
;
	push	ds
	mov	ax, 3506h
	int	21h

	mov	[int06off], bx	;rsnoL[荞݃xN^ۑ
	mov	[int06seg], es

	mov	ax, 350ch
	int	21h

	mov	cx, ds
	mov	[int0coff], bx	;xN^ۑ
	mov	[int0cseg], es
	
	mov	dx, offset int0c
	mov	ax, cs
	mov	ds, ax
	mov	ax, 250ch
	int	21h

	mov	dx, offset int06
	mov	ax, 2506h
	int	21h

	pop	ds
;
;qr|QRQb̊荞݂
;
	in	al, 02h
	iowait
	and	al, 0efh
	out	02h, al

	mov	ax, offset _refresh
	push	ax
	call	_atexit
	add	sp,2

	xor	ax, ax

exit:
	pop	si
	pop	bp
	ret

_rs_init	ENDP


;
;******************************************************
;*                                                    *
;*  荞݃xN^ACQRQb̊荞݂̋֎~  *
;*                                                    *
;*E                                              *
;*@@̃vVW͂b atexit() ɂo^  *
;*    ̂Œڂ͎s邱Ƃ͖AvO  *
;*    IɎIɎsB                    *
;*                                                    *
;******************************************************
;
_refresh	proc	near
	push	ds
;
;qr|QRQb̊荞݂֎~
;
	in	al, 02h
	iowait
	or	al, 10h
	out	02h, al

	mov	al, [int_mask]
	out	I8255A_C, al
;
;荞݃xN^̕A
;
	mov	dx, [int0coff]
	mov	ds, [int0cseg]
	mov	ax, 250ch
	int	21h
	pop	ds
	push	ds
	mov	dx, [int06off]
	mov	ds, [int06seg]
	mov	ax, 2506h
	int	21h
	pop	ds
	ret
_refresh	endp


;
;*****************************************
;*                                       *
;*     rsnoL[荞݃[`      *
;*                                       *
;*@@ rsnoL[tOZbg@@*
;*                                       *
;*****************************************
;
int06	proc near
	cli
	push	ds
	push	ax
	mov	ax, DGROUP
	mov	ds, ax			;f[^ZOg̎擾
	mov	al, 1
	mov	[__stop],al
	pop	ax
	pop	ds
	sti
	iret
int06	endp
;
;*****************************************
;*                                       *
;*     qqcx荞݃[`        *
;*                                       *
;*                                   *
;*   Mobt@ӂĂ.@ *
;*                                       *
;*****************************************
;
int0c	proc near
	cli
	push	ax
	push	bx
	push	si
	push	ds

	mov	ax, DGROUP
	mov	ds, ax			;f[^ZOg̎擾
	mov	si, offset buffer
	mov	bx, [_w_ptr]
	in	al, I8251A_DATA		;f[^ǂݍ
	mov	byte ptr [si+bx], al	;obt@ɃZbg
	inc	bx
	cmp	bx, MAX_BUFFER
	jnz	skip
	mov	bx, 0
skip:
	mov	[_w_ptr], bx		;݃|C^ύX
	mov	ax, [_r_ptr]
	sub	ax, bx
	ja	@f
	add	ax, MAX_BUFFER
@@:
	cmp	ax, FLOW_LIMIT
	jc	flow_ctrl
no_flow:
	pop	ds
	pop	si
	pop	bx
	mov	al, 20h
	out	00h, al			;EOI
	pop	ax
	sti
	iret
flow_ctrl:
	mov	[_flag], 1
	mov	al, 17h
	out	I8251A_CMD, al		;RTS Disable
	jmp	no_flow
int0c	endp


;
;***************************************
;*                                     *
;* int getaux()                        *
;*                                     *
;*     Mobt@P擾      *
;*                                     *
;* Entry:                              *
;*    none                             *
;*                                     *
;* Return:                             *
;*   -1   : f[^Ȃ                 *
;*   -2   : rsnoL[ꂽ@   *
;*  other : Mf[^                 *
;*                                     *
;***************************************
;
_getaux	proc	near
	push	si
	mov	si, offset buffer
	cmp	[__stop], 0		;XgbvL[ꂽH
	mov	ax, -2			;Xgbv
	jnz	no_data
;
	mov	ax, [_w_ptr]
	mov	bx, [_r_ptr]
	cmp	ax, bx			;f[^ȂH
	mov	ax, -1
	jz	no_data
;
	xor	ah, ah
	mov	al, [si+bx]
	inc	bx
	cmp	bx, MAX_BUFFER
	jnz	gal1
	mov	bx, 0
gal1:
	mov	[_r_ptr], bx
	cmp	[_flag], 1
	jnz	no_data
	mov	ax, bx
	mov	bx, [_w_ptr]
	sub	ax, bx
	ja	@f
	add	ax, MAX_BUFFER
@@:
	cmp	ax, FLOW_LIMIT+1
	jc	no_data
	mov	[_flag], 0
	mov	al, 37h
	out	I8251A_CMD, al		;RTS Enable
no_data:
	pop	si
	ret
_getaux	endp


;
;***************************************
;*                                     *
;*  int putaux( int );                 *
;*                                     *
;*     PoCgM                    *
;*                                     *
;* Entry:                              *
;*    int  c                           *
;*                                     *
;* Return:                             *
;*    0 : I@@@@@@@@@@ *
;*   -2 : XgbvL[ꂽ@@@ *
;*                                     *
;***************************************
;
_putaux	proc	near
	push	bp
	mov	bp, sp
;
	cmp	byte ptr [x_flow], 0
	jz	h_flow
	call	_getaux
	cmp	ax, -1
	jz	h_flow
	cmp	al, X_OFF
	jnz	h_flow
xloop:
	cmp	ax, -2
	jz	exit_putaux
	cmp	al, X_ON
	jz	h_flow
	call	_getaux
	jmp	xloop
;
h_flow:
	cmp	[__stop], 0		;XgbvL[ꂽH
	mov	ax, -2			;Xgbv
	jnz	exit_putaux
;
	in	al, I8251A_STAT
	test	al, 1			;MH
	jz	h_flow
put:
	mov	al, byte ptr [bp+4]
	out	I8251A_DATA, al		;M
	xor	ax, ax
exit_putaux:
	pop	bp
	ret
_putaux	endp
;
;***************************************
;*                                     *
;* int checkaux()                      *
;*                                     *
;*   Mobt@󂩂ǂׂ@@*
;*                                     *
;* Entry:                              *
;*    none                             *
;*                                     *
;* Return:                             *
;*    0:f[^                     *
;*   -1:f[^Ȃ                     *
;*   -2:XgbvL[ꂽ@@@   *
;*                                     *
;***************************************
;
_checkaux	proc	near
	cmp	[__stop], 0		;XgbvL[ꂽH
	mov	ax, -2			;Xgbv
	jnz	@f
	mov	ax, [_w_ptr]
	mov	bx, [_r_ptr]
	cmp	ax, bx
	mov	ax, -1
	jz	@f
	xor	ax, ax
@@:
	ret
_checkaux	endp
	end
